/***********************************************************/
/*                                                         */
/* IO WIDGETS                                              */
/*                                                         */
/* R. Marsh, 6/11/18                                       */
/*                                                         */
/***********************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

#ifndef _defines_
#define _defines_

typedef unsigned char uchar;

struct uRGB {
   uchar R, G, B;
};

struct fRGB {
   double R, G, B;
};

#endif
#ifndef _pgmIO_
#define _pgmIO_

/***********************************************************/
/* GLOBAL DEFINES                                          */
/***********************************************************/
typedef unsigned char uchar;

/***********************************************************/
/* FUNCTION PROTOTYPES                                     */
/***********************************************************/
/****************************************/
/* UCHAR_TO_RGB_STRUCT                  */
/****************************************/
struct uRGB** UCHAR_TO_RGB_STRUCT(uchar **, int, int);

/****************************************/
/* RGB_STRUCT_TO_UCHAR                  */
/****************************************/
uchar** RGB_STRUCT_TO_UCHAR(struct uRGB **, int, int);

/****************************************/
/* Clear PGM (XV) comments.             */
/****************************************/
void pgmCommentClear(FILE *);

/****************************************/
/* Read PGM formatted image (2D array). */
/****************************************/
uchar **PGM_FILE_READ_2D(char *, int *, int *, int *);

/****************************************/
/* Read PGM formatted image (1D array). */
/****************************************/
uchar *PGM_FILE_READ_1D(char *, int *, int *, int *);

/****************************************/
/* Write PGM formatted image (1D array).*/
/****************************************/
void PGM_FILE_WRITE_1D(char *, uchar *, int, int, int);

/****************************************/
/* Write PGM formatted image (2D array).*/
/****************************************/
void PGM_FILE_WRITE_2D(char *, uchar **, int, int, int);

#endif

